package cn.com.ctop.toutiao.modules.material.controller;

import cn.com.ctop.toutiao.modules.material.entity.BytedanceImageInfo;
import cn.com.ctop.toutiao.modules.material.service.IBytedanceImageInfoService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 头条图片素材
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-08-01
 */
@Slf4j
@Api(tags = "头条图片素材")
@RestController
@RequestMapping("/ctop/bytedanceImageInfo")
public class BytedanceImageInfoController {
    @Autowired
    private IBytedanceImageInfoService bytedanceImageInfoService;

    /**
     * 分页列表查询
     *
     * @param bytedanceImageInfo
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "头条图片素材-分页列表查询")
    @ApiOperation(value = "头条图片素材-分页列表查询", notes = "头条图片素材-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<BytedanceImageInfo>> queryPageList(BytedanceImageInfo bytedanceImageInfo,
                                                           @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                           @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                           HttpServletRequest req) {
        Result<IPage<BytedanceImageInfo>> result = new Result<>();
        QueryWrapper<BytedanceImageInfo> queryWrapper = QueryGenerator.initQueryWrapper(bytedanceImageInfo, req.getParameterMap());
        Page<BytedanceImageInfo> page = new Page<BytedanceImageInfo>(pageNo, pageSize);
        IPage<BytedanceImageInfo> pageList = bytedanceImageInfoService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param bytedanceImageInfo
     * @return
     */
    @AutoLog(value = "头条图片素材-添加")
    @ApiOperation(value = "头条图片素材-添加", notes = "头条图片素材-添加")
    @PostMapping(value = "/add")
    public Result<BytedanceImageInfo> add(@RequestBody BytedanceImageInfo bytedanceImageInfo) {
        Result<BytedanceImageInfo> result = new Result<>();
        try {
            bytedanceImageInfoService.save(bytedanceImageInfo);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param bytedanceImageInfo
     * @return
     */
    @AutoLog(value = "头条图片素材-编辑")
    @ApiOperation(value = "头条图片素材-编辑", notes = "头条图片素材-编辑")
    @PutMapping(value = "/edit")
    public Result<BytedanceImageInfo> edit(@RequestBody BytedanceImageInfo bytedanceImageInfo) {
        Result<BytedanceImageInfo> result = new Result<BytedanceImageInfo>();
        BytedanceImageInfo bytedanceImageInfoEntity = bytedanceImageInfoService.getById(bytedanceImageInfo.getId());
        if (bytedanceImageInfoEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = bytedanceImageInfoService.updateById(bytedanceImageInfo);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "头条图片素材-通过id删除")
    @ApiOperation(value = "头条图片素材-通过id删除", notes = "头条图片素材-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            bytedanceImageInfoService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "头条图片素材-批量删除")
    @ApiOperation(value = "头条图片素材-批量删除", notes = "头条图片素材-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<BytedanceImageInfo> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<BytedanceImageInfo> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.bytedanceImageInfoService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "头条图片素材-通过id查询")
    @ApiOperation(value = "头条图片素材-通过id查询", notes = "头条图片素材-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<BytedanceImageInfo> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<BytedanceImageInfo> result = new Result<>();
        BytedanceImageInfo bytedanceImageInfo = bytedanceImageInfoService.getById(id);
        if (bytedanceImageInfo == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(bytedanceImageInfo);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<BytedanceImageInfo> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                BytedanceImageInfo bytedanceImageInfo = JSON.parseObject(deString, BytedanceImageInfo.class);
                queryWrapper = QueryGenerator.initQueryWrapper(bytedanceImageInfo, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<BytedanceImageInfo> pageList = bytedanceImageInfoService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "头条图片素材列表");
        mv.addObject(NormalExcelConstants.CLASS, BytedanceImageInfo.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("头条图片素材列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<BytedanceImageInfo> listBytedanceImageInfos = ExcelImportUtil.importExcel(file.getInputStream(), BytedanceImageInfo.class, params);
                bytedanceImageInfoService.saveBatch(listBytedanceImageInfos);
                return Result.ok("文件导入成功！数据行数:" + listBytedanceImageInfos.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
